Index: codes/icosagcm/trunk/src/domain.f90
===================================================================
--- codes/icosagcm/trunk/src/domain.f90	(revision 150)
+++ codes/icosagcm/trunk/src/domain.f90	(revision 151)
@@ -71,4 +71,5 @@
   SUBROUTINE create_domain
   USE grid_param
+  USE mpipara
   IMPLICIT NONE
   INTEGER :: ind,nf,ni,nj,i,j
@@ -98,7 +99,7 @@
           d%ii_end_glo=d%ii_begin_glo+d%ii_nb-1
  
-          IF (ni/=nsplit_i) THEN 
+          IF (ni/=1) THEN 
             d%ii_nb=d%ii_nb+1
-            d%ii_end_glo=d%ii_end_glo+1
+            d%ii_begin_glo=d%ii_begin_glo-1
           ENDIF
          
@@ -115,7 +116,7 @@
           d%jj_end_glo=d%jj_begin_glo+d%jj_nb-1
 
-          IF (nj/=nsplit_j) THEN 
+          IF (nj/=1) THEN 
             d%jj_nb=d%jj_nb+1
-            d%jj_end_glo=d%jj_end_glo+1
+            d%jj_begin_glo=d%jj_begin_glo-1
           ENDIF
 
@@ -142,4 +143,7 @@
           ALLOCATE(d%own(d%iim,d%jjm))
           ALLOCATE(d%ne(0:5,d%iim,d%jjm))
+          
+          IF (is_mpi_root) PRINT *,"Domain ",ind," : size ",d%ii_nb,"x",d%jj_nb
+          
         END DO
       END DO
@@ -261,5 +265,4 @@
             d%neighbour(:,k,i,j)=cell_glo(ind2)%xyz(:)
 
-!            d%ne(k,i,j)=vertex_glo(ii,jj,nf)%ne(k)
             d%ne(k,i,j)=1-2*MOD(k,2)
 
@@ -298,5 +301,5 @@
       edge_glo(e)%assign_pos=k
       edge_glo(e)%assign_delta=delta
-!      PRINT*,"Assign_edge",ind_d,ind,i,j,k,e
+
      END  SUBROUTINE assign_edge
          
Index: codes/icosagcm/trunk/src/dynetat0_gcm_mod.f90
===================================================================
--- codes/icosagcm/trunk/src/dynetat0_gcm_mod.f90	(revision 150)
+++ codes/icosagcm/trunk/src/dynetat0_gcm_mod.f90	(revision 151)
@@ -18,7 +18,6 @@
 CONTAINS
 
-	SUBROUTINE etat0(f_ps,f_phis,f_theta_rhodz,f_u,f_q) 
+  SUBROUTINE etat0(f_ps,f_phis,f_theta_rhodz,f_u,f_q) 
   USE icosa
-  USE caldyn_mod
   USE write_field  
   USE maxicosa
@@ -98,6 +97,4 @@
 !----------------------------------------------------
 !------------- OUTPUT OF Variables 
-	CALL un2ulonlat(f_u,f_buf_i3,f_buf1_i,f_buf2_i) 
-	CALL writefield("buf1",f_buf1_i)
   END SUBROUTINE etat0
 
Index: codes/icosagcm/trunk/src/dynetat0_hz_mod.f90
===================================================================
--- codes/icosagcm/trunk/src/dynetat0_hz_mod.f90	(revision 150)
+++ codes/icosagcm/trunk/src/dynetat0_hz_mod.f90	(revision 151)
@@ -2,5 +2,4 @@
   USE genmod
   USE icosa
-  USE caldyn_gcm_mod 
   IMPLICIT NONE 
   PRIVATE
@@ -23,4 +22,5 @@
   USE write_field  
   USE maxicosa
+  USE wind_mod
         IMPLICIT NONE
      TYPE(t_domain),POINTER :: d 
@@ -97,5 +97,5 @@
 	ENDDO
 !------------- OUTPUT OF Variables 
-	CALL un2ulonlat(f_u,f_buf_i3,f_buf1_i,f_buf2_i) 
+	CALL un2ulonlat(f_u,f_buf1_i,f_buf2_i) 
 	CALL writefield("buf1",f_buf1_i)
   END SUBROUTINE etat0
Index: codes/icosagcm/trunk/src/exner.f90
===================================================================
--- codes/icosagcm/trunk/src/exner.f90	(revision 150)
+++ codes/icosagcm/trunk/src/exner.f90	(revision 151)
@@ -50,5 +50,4 @@
        
        ! for llm layer
-       !$OMP DO
        DO j=jj_begin-offset,jj_end+offset
           DO i=ii_begin-offset,ii_end+offset
@@ -61,5 +60,4 @@
        ! for other layer   
        DO l = llm-1 , 2 , -1
-          !$OMP DO
           DO j=jj_begin-offset,jj_end+offset
              DO i=ii_begin-offset,ii_end+offset
@@ -75,5 +73,4 @@
        
        ! for first layer
-       !$OMP DO
        DO j=jj_begin-offset,jj_end+offset
           DO i=ii_begin-offset,ii_end+offset
@@ -88,5 +85,4 @@
        
        DO l = 2, llm
-          !$OMP DO
           DO j=jj_begin-offset,jj_end+offset
              DO i=ii_begin-offset,ii_end+offset
@@ -99,5 +95,4 @@
     ELSE ! Simple calculation of Exner pressure based on centered average
        ! surface : pks
-       !$OMP DO
        DO j=jj_begin-offset,jj_end+offset
           DO i=ii_begin-offset,ii_end+offset
@@ -109,5 +104,4 @@
        ! 3D : pk
        DO l = 1, llm
-          !$OMP DO
           DO j=jj_begin-offset,jj_end+offset
              DO i=ii_begin-offset,ii_end+offset
Index: codes/icosagcm/trunk/src/geometry.f90
===================================================================
--- codes/icosagcm/trunk/src/geometry.f90	(revision 150)
+++ codes/icosagcm/trunk/src/geometry.f90	(revision 151)
@@ -91,4 +91,5 @@
   IMPLICIT NONE
     INTEGER,INTENT(IN) :: ind
+!$OMP MASTER
     Ai=geom%Ai(ind)
     xyz_i=geom%xyz_i(ind)
@@ -111,5 +112,6 @@
     bi=geom%bi(ind)
     fv=geom%fv(ind)
-    
+!$OMP END MASTER
+!$OMP BARRIER    
   END SUBROUTINE swap_geometry
   
@@ -213,15 +215,8 @@
           ENDDO
         ENDDO
-!        i=ii_begin ; j=jj_begin ; n=(j-1)*iim+i ; xyz_i(n,:)=domain(ind)%xyz(:,i,j) 
-!        i=ii_begin ; j=jj_end   ; n=(j-1)*iim+i ; xyz_i(n,:)=domain(ind)%xyz(:,i,j)
-!        i=ii_end   ; j=jj_begin ; n=(j-1)*iim+i ;   xyz_i(n,:)=domain(ind)%xyz(:,i,j)
-!        PRINT *,"Pb ?? : " 
-!        PRINT *, xyz_i(n,:), domain(ind)%xyz(:,i,j), norm(xyz_i(n,:)- domain(ind)%xyz(:,i,j))
-!        i=ii_end   ; j=jj_end   ; n=(j-1)*iim+i ; xyz_i(n,:)=domain(ind)%xyz(:,i,j)
         
       ENDDO
 
       IF (check) THEN
-!        sum=sum/(ndomain*ii_nb*jj_nb)
         PRINT *,"it = ",it,"  diff centroid circumcenter ",sum
       ENDIF 
@@ -287,8 +282,4 @@
             ne(n,k+1)=d%ne(k,i,j)
           ENDDO
-                  
-!          xyz_i(n,:)=d%xyz(:,i,j) 
-!          xyz_v(n+z_up,:)=d%vertex(:,vup-1,i,j) 
-!          xyz_v(n+z_down,:)=d%vertex(:,vdown-1,i,j) 
 
           vect(:,1)=xyz_v(n+z_rup,:)
@@ -309,23 +300,11 @@
           bi(n)=0. 
         
-!          CALL dist_cart(d%xyz(:,i,j),d%neighbour(:,right-1,i,j),de(n+u_right))
-!          CALL dist_cart(d%xyz(:,i,j),d%neighbour(:,lup-1,i,j),de(n+u_lup))
-!          CALL dist_cart(d%xyz(:,i,j),d%neighbour(:,ldown-1,i,j),de(n+u_ldown))
-
           CALL dist_cart(xyz_i(n,:),xyz_i(n+t_right,:),de(n+u_right))
           CALL dist_cart(xyz_i(n,:),xyz_i(n+t_lup,:),de(n+u_lup))
           CALL dist_cart(xyz_i(n,:),xyz_i(n+t_ldown,:),de(n+u_ldown))
           
-!          CALL div_arc_bis(d%xyz(:,i,j),d%neighbour(:,right-1,i,j),0.5,xyz_e(n+u_right,:))
-!          CALL div_arc_bis(d%xyz(:,i,j),d%neighbour(:,lup-1,i,j),0.5,xyz_e(n+u_lup,:))
-!          CALL div_arc_bis(d%xyz(:,i,j),d%neighbour(:,ldown-1,i,j),0.5,xyz_e(n+u_ldown,:))
-
           CALL div_arc_bis(xyz_i(n,:),xyz_i(n+t_right,:),0.5,xyz_e(n+u_right,:))
           CALL div_arc_bis(xyz_i(n,:),xyz_i(n+t_lup,:),0.5,xyz_e(n+u_lup,:))
           CALL div_arc_bis(xyz_i(n,:),xyz_i(n+t_ldown,:),0.5,xyz_e(n+u_ldown,:))
-         
-!          CALL dist_cart(d%vertex(:,vrdown-1,i,j),d%vertex(:,vrup-1,i,j),le(n+u_right))
-!          CALL dist_cart(d%vertex(:,vup-1,i,j),d%vertex(:,vlup-1,i,j),le(n+u_lup))
-!          CALL dist_cart(d%vertex(:,vldown-1,i,j),d%vertex(:,vdown-1,i,j),le(n+u_ldown))
 
           CALL dist_cart(xyz_v(n+z_rdown,:), xyz_v(n+z_rup,:),le(n+u_right))
@@ -335,6 +314,4 @@
           Ai(n)=0
           DO k=0,5
-!            CALL surf_triangle(d%xyz(:,i,j),d%neighbour(:,k,i,j),d%neighbour(:,MOD((k+1+6),6),i,j),surf_v(k+1))
-!            CALL surf_triangle(d%xyz(:,i,j),d%vertex(:,MOD((k-1+6),6),i,j),d%vertex(:,k,i,j),surf(k+1))
             CALL surf_triangle(xyz_i(n,:),xyz_i(n+t_pos(k+1),:),xyz_i(n+t_pos(MOD((k+1+6),6)+1),:),surf_v(k+1))
             CALL surf_triangle(xyz_i(n,:),xyz_v(n+z_pos(MOD((k-1+6),6)+1),:),xyz_v(n+z_pos(k+1),:),surf(k+1))
@@ -414,6 +391,4 @@
           
           DO k=0,5
-!            CALL surf_triangle(d%xyz(:,i,j),d%vertex(:,k,i,j),d%neighbour(:,k,i,j),S1)
-!            CALL surf_triangle(d%xyz(:,i,j),d%vertex(:,k,i,j),d%neighbour(:,MOD(k+1+6,6),i,j),S2)
             CALL surf_triangle(xyz_i(n,:), xyz_v(n+z_pos(k+1),:), xyz_i(n+t_pos(k+1),:),S1)
             CALL surf_triangle(xyz_i(n,:), xyz_v(n+z_pos(k+1),:), xyz_i(n+t_pos(MOD(k+1+6,6)+1),:),S2)
@@ -516,6 +491,5 @@
     CALL transfert_request(geom%centroid,req_i1)
     CALL surf_triangle(d%xyz(:,ii_begin,jj_begin),d%xyz(:,ii_begin,jj_end),d%xyz(:,ii_end,jj_begin),S)
-!    PRINT *,"Surf triangle : ",S*20/(4*Pi)
-  
+ 
   END SUBROUTINE set_geometry
   
Index: codes/icosagcm/trunk/src/icosa_gcm.f90
===================================================================
--- codes/icosagcm/trunk/src/icosa_gcm.f90	(revision 150)
+++ codes/icosagcm/trunk/src/icosa_gcm.f90	(revision 151)
@@ -6,5 +6,7 @@
   USE wind_mod
   USE mpipara
+  USE omp_para
   USE vertical_interp_mod
+  USE trace
   IMPLICIT NONE
   
@@ -21,30 +23,11 @@
   CALL init_earth_const 
   CALL init_grid_param
+  CALL init_omp_para
   CALL compute_metric
   CALL compute_domain
   CALL init_transfert
   CALL init_writefield
+  CALL init_trace
 
-!  CALL allocate_field(sum_ne,field_T,type_real)
-!  CALL allocate_field_glo(sum_ne_glo,field_T,type_real)
-!  
-! DO ind=1,ndomain
-!   CALL swap_dimensions(ind)
-!   pt_sum_ne=sum_ne(ind)
-!   DO j=jj_begin,jj_end
-!     DO i=ii_begin,ii_end    
-!       n=(j-1)*iim+i
-!       pt_sum_ne(n)=domloc_glo_ind(ind)
-!     ENDDO
-!   ENDDO
-! ENDDO
-
-! CALL WriteField("domain",sum_ne)
-! CALL WriteField_mpi("domain",sum_ne)
-! CALL transfert_request(sum_ne,req_i1)
-! CALL WriteField_mpi("domain",sum_ne)
-! CALL close_files
-! CALL finalize_mpipara
-! STOP
   
   CALL compute_geometry
@@ -80,8 +63,13 @@
   
   CALL WriteField("Ai",geom%Ai)
-!  CALL WriteField("sum_ne",sum_ne)
+
   IF (is_mpi_root) CALL write_apbp
   CALL init_time
+
+  CALL init_timeloop
+
+!$OMP PARALLEL
   CALL timeloop
+!$OMP END PARALLEL
 
   CALL close_files
Index: codes/icosagcm/trunk/src/mpi_mod.F90
===================================================================
--- codes/icosagcm/trunk/src/mpi_mod.F90	(revision 150)
+++ codes/icosagcm/trunk/src/mpi_mod.F90	(revision 151)
@@ -11,4 +11,5 @@
   INTEGER :: MPI_INFO_NULL
   INTEGER :: MPI_STATUS_SIZE 
+  INTEGER,PARAMETER :: MPI_ADDRESS_KIND=KIND(INTEGER)
 #endif
 
@@ -40,8 +41,14 @@
  END
 
+ SUBROUTINE MPI_ISSEND
+ END
+
  SUBROUTINE MPI_IRECV
  END
 
  SUBROUTINE MPI_WAITALL
+ END
+
+ SUBROUTINE MPI_TESTALL
  END
 
@@ -51,4 +58,10 @@
  SUBROUTINE MPI_ALLGATHER
  END
+ 
+ SUBROUTINE MPI_TYPE_EXTENT
+ END
+ 
+ SUBROUTINE MPI_ALLOC_MEM
+ END
 
 #endif
Index: codes/icosagcm/trunk/src/mpipara.F90
===================================================================
--- codes/icosagcm/trunk/src/mpipara.F90	(revision 150)
+++ codes/icosagcm/trunk/src/mpipara.F90	(revision 151)
@@ -8,4 +8,8 @@
   LOGICAL,SAVE :: using_mpi
   LOGICAL,SAVE :: is_mpi_root
+  
+  INTERFACE allocate_mpi_buffer
+    MODULE PROCEDURE allocate_mpi_buffer_r2, allocate_mpi_buffer_r3,allocate_mpi_buffer_r4
+  END INTERFACE allocate_mpi_buffer
 
 CONTAINS
@@ -48,4 +52,67 @@
    END SUBROUTINE  finalize_mpipara
    
+
+  SUBROUTINE allocate_mpi_buffer_r2(buffer,length)
+  USE ISO_C_BINDING
+  USE mpi_mod
+  USE prec
+  IMPLICIT NONE
+    REAL(rstd), POINTER :: buffer(:)
+    INTEGER,INTENT(IN)  :: length
+
+    TYPE(C_PTR)         :: base_ptr
+    INTEGER(KIND=MPI_ADDRESS_KIND) :: size
+    INTEGER :: real_size,ierr
+    
+    CALL MPI_TYPE_EXTENT(MPI_REAL8, real_size, ierr)
+    size=length*real_size
+    
+    CALL MPI_ALLOC_MEM(size,MPI_INFO_NULL,base_ptr,ierr)
+    CALL C_F_POINTER(base_ptr, buffer, (/ length /))
+
+   END SUBROUTINE allocate_mpi_buffer_r2
+
+  SUBROUTINE allocate_mpi_buffer_r3(buffer,length,dim3)
+  USE ISO_C_BINDING
+  USE mpi_mod
+  USE prec
+    IMPLICIT NONE
+    REAL(rstd), POINTER :: buffer(:,:)
+    INTEGER,INTENT(IN)  :: length
+    INTEGER,INTENT(IN)  :: dim3
+
+    TYPE(C_PTR)         :: base_ptr
+    INTEGER(KIND=MPI_ADDRESS_KIND) :: size
+    INTEGER :: real_size,ierr
+    
+    CALL MPI_TYPE_EXTENT(MPI_REAL8, real_size, ierr)
+    size=length*real_size*dim3
+    
+    CALL MPI_ALLOC_MEM(size,MPI_INFO_NULL,base_ptr,ierr)
+    CALL C_F_POINTER(base_ptr, buffer, (/ length,dim3 /))
+    
+   END SUBROUTINE allocate_mpi_buffer_r3
+
+  SUBROUTINE allocate_mpi_buffer_r4(buffer,length,dim3,dim4)
+  USE ISO_C_BINDING
+  USE mpi_mod
+  USE prec
+  IMPLICIT NONE
+    REAL(rstd), POINTER :: buffer(:,:,:)
+    INTEGER,INTENT(IN)  :: length
+    INTEGER,INTENT(IN)  :: dim3
+    INTEGER,INTENT(IN)  :: dim4
+
+    TYPE(C_PTR)         :: base_ptr
+    INTEGER(KIND=MPI_ADDRESS_KIND) :: size
+    INTEGER :: real_size,ierr
+    
+    CALL MPI_TYPE_EXTENT(MPI_REAL8, real_size, ierr)
+    size=length*real_size*dim3*dim4
+    
+    CALL MPI_ALLOC_MEM(size,MPI_INFO_NULL,base_ptr,ierr)
+    CALL C_F_POINTER(base_ptr, buffer, (/ length, dim3, dim4 /))
+    
+   END SUBROUTINE allocate_mpi_buffer_r4
    
 END MODULE mpipara
Index: codes/icosagcm/trunk/src/omp_para.F90
===================================================================
--- codes/icosagcm/trunk/src/omp_para.F90	(revision 151)
+++ codes/icosagcm/trunk/src/omp_para.F90	(revision 151)
@@ -0,0 +1,100 @@
+MODULE omp_para
+
+  INTEGER,SAVE :: omp_size
+  INTEGER,SAVE :: omp_rank
+!$OMP THREADPRIVATE(omp_rank)
+
+  LOGICAL,SAVE :: omp_first
+  LOGICAL,SAVE :: omp_last
+  LOGICAL,SAVE :: omp_master
+!$OMP THREADPRIVATE(omp_first, omp_last,omp_master)
+
+  INTEGER,SAVE :: ll_begin
+  INTEGER,SAVE :: ll_beginp1
+  INTEGER,SAVE :: ll_end
+  INTEGER,SAVE :: ll_endm1
+  INTEGER,SAVE :: ll_endp1
+!$OMP THREADPRIVATE(ll_begin,ll_beginp1,ll_end,ll_endm1,ll_endp1)
+  LOGICAL,SAVE :: using_openmp
+
+CONTAINS
+
+
+  SUBROUTINE init_omp_para
+  USE grid_param
+#ifdef CPP_USING_OPENMP
+  USE omp_lib
+#endif
+  IMPLICIT NONE
+  INTEGER :: ll_nb,i
+
+#ifdef CPP_USING_OPENMP
+  using_openmp=.TRUE.
+#else
+  using_openmp=.FALSE.
+#endif
+
+  IF (using_openmp) THEN    
+!$OMP PARALLEL PRIVATE(ll_nb,i)
+  
+!$OMP MASTER
+#ifdef CPP_USING_OPENMP
+    omp_size=OMP_GET_NUM_THREADS()
+#endif
+!$OMP END MASTER
+!$OMP BARRIER
+#ifdef CPP_USING_OPENMP
+    omp_rank=OMP_GET_THREAD_NUM()
+#endif
+    omp_first=.FALSE.
+    omp_last=.FALSE.
+    omp_master=.FALSE.
+    
+    IF (omp_rank==0) THEN
+      omp_first=.TRUE.
+      omp_master=.TRUE.
+    ENDIF
+    
+    IF (omp_rank==omp_size-1) omp_last=.TRUE.
+    
+    ll_end=0
+    DO i=0,omp_rank
+      ll_begin=ll_end+1
+      ll_nb=llm/omp_size
+      IF (MOD(llm,omp_size)>i) ll_nb=ll_nb+1
+      ll_end=ll_begin+ll_nb-1
+    ENDDO
+    
+    ll_beginp1=ll_begin
+    ll_endp1=ll_end
+    ll_endm1=ll_end
+
+    IF (omp_first) ll_beginp1=ll_begin+1
+    IF (omp_last) ll_endp1=ll_endp1+1
+    IF (omp_last) ll_endm1=ll_endm1-1
+
+!$OMP END PARALLEL
+
+   ELSE
+     omp_size=1
+     omp_rank=0
+     omp_first=.TRUE.
+     omp_last=.TRUE.
+     omp_master=.TRUE.
+     ll_begin=1
+     ll_beginp1=2
+     ll_end=llm
+     ll_endm1=llm-1
+     ll_endp1=llm+1
+   ENDIF
+   
+  END SUBROUTINE init_omp_para
+
+  
+END MODULE omp_para
+    
+    
+      
+             
+  
+    
Index: codes/icosagcm/trunk/src/pression.f90
===================================================================
--- codes/icosagcm/trunk/src/pression.f90	(revision 150)
+++ codes/icosagcm/trunk/src/pression.f90	(revision 151)
@@ -33,5 +33,4 @@
 
     DO    l    = 1, llm+1
-!$OMP DO
       DO j=jj_begin-offset,jj_end+offset
         DO i=ii_begin-offset,ii_end+offset
Index: codes/icosagcm/trunk/src/theta_rhodz.f90
===================================================================
--- codes/icosagcm/trunk/src/theta_rhodz.f90	(revision 150)
+++ codes/icosagcm/trunk/src/theta_rhodz.f90	(revision 151)
@@ -83,14 +83,8 @@
     REAL(rstd),ALLOCATABLE,SAVE :: p(:,:)
 
-!$OMP BARRIER
-!$OMP MASTER
-      ALLOCATE( p(iim*jjm,llm+1))
-!$OMP END MASTER
-!$OMP BARRIER
-
+    ALLOCATE( p(iim*jjm,llm+1))
     CALL compute_pression(ps,p,offset)
     
     DO    l    = 1, llm
-!$OMP DO
       DO j=jj_begin-offset,jj_end+offset
         DO i=ii_begin-offset,ii_end+offset
@@ -101,9 +95,5 @@
     ENDDO
 
-!$OMP BARRIER
-!$OMP MASTER
-      DEALLOCATE( p)
-!$OMP END MASTER
-!$OMP BARRIER    
+    DEALLOCATE( p)
 
   END SUBROUTINE compute_theta2theta_rhodz
@@ -120,9 +110,6 @@
     REAL(rstd),SAVE,ALLOCATABLE :: p(:,:)
 
-!$OMP BARRIER
-!$OMP MASTER
-      ALLOCATE( p(iim*jjm,llm+1))
-!$OMP END MASTER
-!$OMP BARRIER
+    ALLOCATE( p(iim*jjm,llm+1))
+
     CALL compute_pression(ps,p,offset)
     
@@ -136,9 +123,5 @@
     ENDDO
 
-!$OMP BARRIER
-!$OMP MASTER
-      DEALLOCATE( p)
-!$OMP END MASTER
-!$OMP BARRIER    
+    DEALLOCATE( p)
     
   END SUBROUTINE compute_theta_rhodz2theta
@@ -193,5 +176,4 @@
         DO i=ii_begin-offset,ii_end+offset
           ij=(j-1)*iim+i
-!          temp(ij,l) = ( theta_rhodz(ij,l) / ((p(ij,l)-p(ij,l+1))/g) ) * pk(ij,l) / cpp
           theta_rhodz(ij,l) = temp(ij,l) * ((p(ij,l)-p(ij,l+1))/g) / (pk(ij,l) / cpp )
         ENDDO
Index: codes/icosagcm/trunk/src/time.f90
===================================================================
--- codes/icosagcm/trunk/src/time.f90	(revision 150)
+++ codes/icosagcm/trunk/src/time.f90	(revision 151)
@@ -119,4 +119,6 @@
   INTEGER :: status
   REAL(rstd) ::time_array(1)
+
+!$OMP MASTER
     time_array(1)=time
   
@@ -126,4 +128,5 @@
       status=NF90_SYNC(ncid)
     ENDIF
+!$OMP END MASTER
 
   END SUBROUTINE update_time_counter    
